<?php
/**
 * Find and Replace for one language in WPML
 *
 * This plugin improves upon the database search/replace functionality offered
 * by some other plugins- offering serialization support, the ability to
 * select specific language tables, and the ability to run replace.
 *
 * @since             1.0.0
 *
 * @wordpress-plugin
 * Plugin Name:       Find and Replace for one language in WPML
 * Plugin URI:        https://standardtouch.com
 * Description:       A small plugin for running a find/replace on your WordPress database for one language.
 * Version:           1.0.0
 * Author:            stouch
 * Author URI:        http://standardtouch.com/
 * Text Domain:       multilingual-lang-find-replace
 * Domain Path:       /languages

*/

    if ( ! defined( 'ABSPATH' ) ) {
        exit; // Exit if accessed directly
    }

add_action( 'admin_menu', 'extra_post_info_menu' );

function extra_post_info_menu(){

  $page_title = 'Find and Replace for one language in WPML';
  $menu_title = 'Find and Replace for one language in WPML';
  $capability = 'manage_options';
  $menu_slug  = 'multilingual-Find-and-Replace';
  $function   = 'extra_post_info_page';
  $icon_url   = 'dashicons-media-code';
  $position   = 4;

  add_menu_page( $page_title,
                 $menu_title,
                 $capability,
                 $menu_slug,
                 $function,
                 $icon_url,
                 $position );
}

if( !function_exists("extra_post_info_page") )
{
function extra_post_info_page(){
?>



<div id="bsr-search-replace-wrap">

	<div class="inside">

		<p><?php _e( 'This tool allows you to Find and Replace text for one language in your database.', 'multilingual-lang-find-replace' ); ?></p>
		<p><?php _e( 'To get started, use the form below to enter the text to be replaced and select the tables to update.', 'multilingual-lang-find-replace' ); ?></p>
		<p><?php _e( '<strong>WARNING:</strong> Make sure you backup your database before using this plugin!', 'multilingual-lang-find-replace' ); ?></p>

	 <?php echo'
    <form action="' . $_SERVER['REQUEST_URI'] . '" method="POST">

    <div>
    <label for="search_field">Find Keyword</label>
    <input type="text" name="search_field" value="' . ( isset( $_POST['search_field']) ? $search_field : null ) . '">
    </div>

    <div>
    <label for="replace_with">Replace With</label>
    <input type="text" name="replace_with" value="' . ( isset( $_POST['replace_with']) ? $replace_with : null ) . '">
    </div>

    <div>
    <label for="post_type_slug">Post Type Slug</label>
    <input type="text" name="post_type_slug" value="' . ( isset( $_POST['post_type_slug']) ? $post_type_slug : null ) . '">
    </div>

    <div>
    <label for="language_code">Language Code (Replacing Language)</label>
    <input type="text" name="language_code" value="' . ( isset( $_POST['language_code']) ? $language_code : null ) . '">
    </div>

    <input type="submit" name="submit" value="submit"/>
    </form>';

?>
	</div>

</div>


<?php
    // if the submit button is clicked, send the email

        // sanitize form values
       $search    = sanitize_text_field( $_POST["search_field"] );
      $replace    = sanitize_text_field( $_POST["replace_with"] );
      $post_type_multilingual    = sanitize_text_field( $_POST["post_type_slug"] );
       $language    = sanitize_text_field( $_POST["language_code"] );

            global $wpdb;
      //      $wpdb->show_errors();

  //    $result =     $wpdb->query("UPDATE $wpdb->posts INNER JOIN $wpdb->icl_translations ON $wpdb->posts.ID = $wpdb->icl_translations.element_id AND $wpdb->icl_translations.element_type = CONCAT('post_', $wpdb->posts.post_type) SET post_content =replace(post_content,'".$search."','".$replace."') WHERE $wpdb->posts.post_type = '".$post_type_multilingual."' AND $wpdb->posts.post_status = 'publish' AND ( ( $wpdb->icl_translations.language_code = '".$language."' AND $wpdb->posts.post_type = '".$post_type_multilingual."' ) )");
//      echo $result;


 $result =     $wpdb->query("UPDATE $wpdb->posts INNER JOIN ".$wpdb->prefix."icl_translations ON $wpdb->posts.ID = ".$wpdb->prefix."icl_translations.element_id AND ".$wpdb->prefix."icl_translations.element_type = CONCAT('post_', $wpdb->posts.post_type) SET post_content =replace(post_content,'".$search."','".$replace."') WHERE $wpdb->posts.post_type = '".$post_type_multilingual."' AND $wpdb->posts.post_status = 'publish' AND ( ( ".$wpdb->prefix."icl_translations.language_code = '".$language."' AND $wpdb->posts.post_type = '".$post_type_multilingual."' ) )");
      echo $result . 'Rows Effected';
   //   $wpdb->print_error();


}
}
